function FileDownloader(url, type) {

	var dm = Components.classes["@mozilla.org/download-manager;1"].getService(Components.interfaces.nsIDownloadManager);
	var ioservice = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var mime = Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService);
	var sourceUri = ioservice.newURI(url, null, null);

	var filename = decodeURL(url);
	filename = filename.substring(filename.lastIndexOf("/") + 1)

	           var targetFile = getTargetFile(filename, targetFile);

	if(targetFile !== null)
		var targetUri = ioservice.newFileURI(targetFile);

	var ext = (filename.lastIndexOf(".") != -1 ? filename.substring(filename.lastIndexOf(".") + 1) : "");
	var mimeType = (type === "" ? null : mime.getFromTypeAndExtension(type, ext));
	var persist = makeWebBrowserPersist();

	var sysListener = null;
	var download = null;
	var self = this;
	var timerId = null;

	this.start = function() {

		             try {
			             if(targetFile === null)
				             return;

			             dm.addDownload(0, sourceUri, targetUri, filename, mimeType, null, null, null, persist);
			             dm.open(window._content, targetFile.path)
			             download = dm.getDownload(targetFile.path);

			             const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
			             persist.persistFlags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE |
			                                    nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;

			             persist.progressListener = download;
			             persist.saveURI(sourceUri, null, null, null, null, targetFile);

		             }
		             catch (e) {
			             alert(e);
		             }
	             };

	function makeWebBrowserPersist() {
		const persistContractID = "@mozilla.org/embedding/browser/nsWebBrowserPersist;1";
		const persistIID = Components.interfaces.nsIWebBrowserPersist;
		return Components.classes[persistContractID].createInstance(persistIID);
	}

	function getTargetFile(filename) {
		const nsILocalFile = Components.interfaces.nsILocalFile;

		var dir = null;
		var branch = getPrefsBrowserDownload("browser.download.");
		dir = null;

		try {
			dir = branch.getComplexValue("dir", nsILocalFile);
		}
		catch(e) {}

		if(dir === null) {
			try {
				dir = branch.getComplexValue("downloadDir", nsILocalFile);
			}
			catch(e) {}
		}

		if(dir === null) {
			try {
				dir = branch.getComplexValue("defaultDir", nsILocalFile);
			}
			catch(e) {}
		}

		var autoDownload = branch.getBoolPref("useDownloadDir");
		if (autoDownload && dir && dir.exists()) {
			dir.append(filename);
			return dir;
		}

		//No auto download, show the file picker
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		var titleKey = "Save File";
		fp.init(window, titleKey, Components.interfaces.nsIFilePicker.modeSave);

		try {
			if (dir.exists())
				fp.displayDirectory = dir;
		}
	catch (e) {}

		fp.defaultString = filename;

		if (fp.show() == Components.interfaces.nsIFilePicker.returnCancel || !fp.file)
			return null;

		return fp.file;
	}

	function getPrefsBrowserDownload(branch) {
		const prefSvcContractID = "@mozilla.org/preferences-service;1";
		const prefSvcIID = Components.interfaces.nsIPrefService;
		return Components.classes[prefSvcContractID].getService(prefSvcIID).getBranch(branch);
	}
}

