function LockManager() {
	try {
		var locks = [];
		var lockFile = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);

		var filename = gVars.base_url.substring(gVars.base_url.indexOf("//") + 2);
		filename = filename.replace(/\//g, "_")
		           filename = gVars.uName + "@" + filename;

		lockFile.append("dav_locks");
		if(!lockFile.exists())
			lockFile.create(1, 493);

		lockFile.append(filename);

		this.getToken = function(fn) {
			                var tok = null;
			                do {
				                tok = this.getSingleToken(fn);
				                if(tok === null)
					                fn = fn.substring(0, fn.lastIndexOf("/"));

			                }
			                while(fn !== "" && fn !== gVars.start_dir && (tok === null));

			                return tok;
		                };

		this.getSingleToken = function(f) {
			                      if(f[f.length - 1] === "/")
				                      f = f.substring(0, f.length - 1);

			                      for(var x = 0; x < locks.length; x++) {
				                      if(locks[x].file === f) {
					                      return locks[x].token;
				                      }
			                      }
			                      return null;
		                      };

		this.addLock = function(f, t) {
			               if(this.getSingleToken(f) !== null)
				               this.removeLock(f);

			               locks[locks.length] = new lock(f, t);
		               };

		this.removeLock = function(f) {
			                  if(f[f.length - 1] === "/")
				                  f = f.substring(0, f.length - 1);

			                  for(var x = 0; x < locks.length; x++) {
				                  if(locks[x].file === f) {
					                  locks.splice(x, 1);
					                  return;
				                  }
			                  }
		                  };

		this.loadLocks = function() {
			                 try {
				                 if(!lockFile.exists())
					                 return;
				                 var input = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
				                 input.init(lockFile, 0x01, 00004, null);

				                 input.QueryInterface(Components.interfaces.nsILineInputStream);

				                 var hasmore = (input.available() > 0);
				                 while(hasmore) {
					                 var f = {}, t = {};

					                 hasmore = input.readLine(f);

					                 if(!hasmore)
						                 throw("Malformed lock file");

					                 hasmore = input.readLine(t);

					                 f = f.value;
					                 t = t.value;

					                 this.addLock(f.substring(f.indexOf(":") + 1), t.substring(t.indexOf(":") + 1));
				                 }
				                 input.close();

			                 }
			                 catch(e) {
				                 alert("LockManager::loadLocks: " + e);
			                 }
		                 };

		this.saveLocks = function() {
			                 try {
				                 if(locks.length === 0)
					                 return;

				                 if(!lockFile.exists())
					                 lockFile.create(0, 420);

				                 var out = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
				                 out.init(lockFile, 0x04 | 0x08 | 0x20, 420, 0);

				                 var d = new Date();
				                 out.QueryInterface(Components.interfaces.nsIOutputStream);
				                 for(var x = 0; x < locks.length; x++) {
					                 out.write("file:" + locks[x].file + "\ntoken:" + locks[x].token + "\n", 13 + locks[x].file.length + locks[x].token.length);
				                 }
				                 out.flush();
				                 out.close();
			                 }
			                 catch(e) {
				                 alert("LockManager::saveLocks: " + e);
			                 }
		                 };

		this.printLocks = function() {
			                  try {
				                  var str = "Lock Manager: \n";
				                  for(var x = 0; x < locks.length; x++) {
					                  str += "   File: " + locks[x].file + "\n     Token: " + locks[x].token + "\n";
				                  }

				                  alert(str);
			                  }
			                  catch(e) {
				                  alert("LockManager::printLocks : " + e);
			                  }
		                  };

		function lock(f, t) {
			if(f[f.length - 1] === "/")
				f = f.substring(0, f.length - 1);

			this.file = f;
			this.token = t;
		}

	}
	catch(e) {
		alert("LockManager: " + e);
	}
}

